<template>
  <q-modal
    :value="!!redactor"
    maximized
    ref="modal"
    @hide="$emit('close')"
  >
    <div class="flex items-start q-pa-lg">
      <div class="flex items-center justify-between full-width">
        <div class="q-title">{{isNewRecord ? 'Create new' : 'Update'}} <u>{{ redactor.config.collection_id }}</u> record</div>
        <div>
          <q-btn
            round
            color="green"
            icon="save"
            size="md"
          />
          <q-btn
            round
            color="red"
            icon="close"
            size="md"
            class="q-ml-sm"
            @click="close"
          />
        </div>
      </div>
      <div
        v-for="(group, index) in availableGroups"
        :key="index"
        class="q-mt-md"
        :style="{
          width: `${group.width || 100}%`
        }"
      >
        <group
          :group="group"
          :record="redactor.record"
        />
      </div>
    </div>
  </q-modal>
</template>

<script>
  import Group from './group';

  export default {
    name: 'redactor',
    components: { Group },
    computed: {
      isNewRecord() {
        return this.redactor.isNewRecord;
      },
      availableGroups() {
        return this.redactor.config.editors.filter(({ useInEditor }) => useInEditor);
      },
    },
    methods: {
      close() {
        this.$refs.modal.hide();
      },
    },
    props: {
      redactor: {
        type: Object,
      },
    },
  };
</script>
